



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux下Keepalived+LVS-DR模式配置高可用负载均衡集群</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux下Keepalived+LVS-DR模式配置高可用负载均衡集群</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-09 07:37:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一、环境说明：</h2>
<p>&#160;&#160;&#160; 操作系统：Centos-6.5_x86_64</p>
<p>&#160;&#160; keepalived软件安装在node2和node3机器上。</p>
<p>&#160;&#160;&#160; 实际安装之前，<strong>先关闭keepalived节点（node2,node3）上的防火墙</strong>。</p>
<div>
<pre class="prettyprint linenums">[root@node2 ~]# service iptables stop</pre>
</div>
<h2>二、软件安装：</h2>
<p>&#160;&#160;&#160; 这里需要安装的软件是keepalived。node2和node3都需要安装。</p>
<div>
<pre class="prettyprint linenums">[root@node2 ~]# yum install keepalived</pre>
</div>
<p>&#160;&#160;&#160; 安装完毕后，配置文件在/etc/keepalived/keepalived.conf下。</p>
<h2>三、配置文件：</h2>
<p>1、MASTER配置文件（node2）：</p>
<div>
<pre class="prettyprint linenums">! Configuration File for keepalived

bal_defs {<br />
   notification_email {<br />
     root@localhost<br />
   }<br />
   notification_email_from laoxiao@localhost<br />
   smtp_server 127.0.0.1<br />
   smtp_connect_timeout 30<br />
   router_id LVS_DEVEL<br />
}

vrrp_instance VI_1 {<br />
    state MASTER<br />
    interface eth0<br />
    virtual_router_id 51<br />
    priority 100<br />
    advert_int 1<br />
    authentication {<br />
        auth_type PASS<br />
        auth_pass 1111<br />
    }<br />
    virtual_ipaddress {<br />
        192.168.103.100/24 dev eth0 label eth0:1<br />
    }<br />
}

virtual_server 192.168.103.100 80 {<br />
    delay_loop 6<br />
    lb_algo wrr<br />
    lb_kind DR<br />
    nat_mask 255.255.255.0<br />
    persistence_timeout 50<br />
    protocol TCP

    real_server 192.168.103.101 80 {<br />
        weight 1<br />
        HTTP_GET {<br />
            url {<br />
              path /<br />
              status_code 200<br />
            }<br />
            connect_timeout 3<br />
            nb_get_retry 3<br />
            delay_before_retry 3<br />
        }<br />
    }<br />
    real_server 192.168.103.105 80 {<br />
        weight 1<br />
        HTTP_GET {<br />
            url {<br />
              path /<br />
              status_code 200<br />
            }<br />
            connect_timeout 3<br />
            nb_get_retry 3<br />
            delay_before_retry 3<br />
        }<br />
    }<br />
}</pre>
</div>
<p>2、BACKUP配置文件（node3）：</p>
<div>
<pre class="prettyprint linenums">! Configuration File for keepalived

bal_defs {<br />
   notification_email {<br />
     root@localhost<br />
   }<br />
   notification_email_from laoxiao@localhost<br />
   smtp_server 127.0.0.1<br />
   smtp_connect_timeout 30<br />
   router_id LVS_DEVEL<br />
}

vrrp_instance VI_1 {<br />
    state BACKUP<br />
    interface eth0<br />
    virtual_router_id 51<br />
    priority 50<br />
    advert_int 1<br />
    authentication {<br />
        auth_type PASS<br />
        auth_pass 1111<br />
    }<br />
    virtual_ipaddress {<br />
        192.168.103.100/24 dev eth0 label eth0:1<br />
    }<br />
}

virtual_server 192.168.103.100 80 {<br />
    delay_loop 6<br />
    lb_algo wrr<br />
    lb_kind DR<br />
    nat_mask 255.255.255.0<br />
    persistence_timeout 50<br />
    protocol TCP

    real_server 192.168.103.101 80 {<br />
        weight 1<br />
        HTTP_GET {<br />
            url {<br />
              path /<br />
              status_code 200<br />
            }<br />
            connect_timeout 3<br />
            nb_get_retry 3<br />
            delay_before_retry 3<br />
        }<br />
    }<br />
    real_server 192.168.103.105 80 {<br />
        weight 1<br />
        HTTP_GET {<br />
            url {<br />
              path /<br />
              status_code 200<br />
            }<br />
            connect_timeout 3<br />
            nb_get_retry 3<br />
            delay_before_retry 3<br />
        }<br />
    }<br />
}</pre>
</div>
<h2>四、测试：</h2>
<h3>1、首先分别启动node2和node3上的keepalived服务：</h3>
<div>
<pre class="prettyprint linenums">[root@node2 ~]# service keepalived start<br />
[root@node3 ~]# service keepalived start</pre>
</div>
<p>启动时产生的日志在/var/log/messages文件中，可以观察其中的日志。MASTER效果如下：BACKUP会略有不同。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/587689/201512/587689-20151228182551792-586468404.png" /></p>
<p>&#160;</p>
<h3>2、查看node2(MASTER)中的状态：</h3>
<div>
<pre class="prettyprint linenums">[root@node2 ~]# ifconfig<br />
eth0      Link encap:Ethernet  HWaddr 00:0C:29:CE:06:D7<br />
          inet addr:192.168.103.102  Bcast:192.168.103.255  Mask:255.255.255.0<br />
          inet6 addr: fe80::20c:29ff:fece:6d7/64 Scope:Link<br />
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1<br />
          RX packets:11485 errors:0 dropped:0 overruns:0 frame:0<br />
          TX packets:33202 errors:0 dropped:0 overruns:0 carrier:0<br />
          collisions:0 txqueuelen:1000<br />
          RX bytes:2217383 (2.1 MiB)  TX bytes:2537512 (2.4 MiB)

eth0:1    Link encap:Ethernet  HWaddr 00:0C:29:CE:06:D7<br />
          inet addr:192.168.103.100  Bcast:0.0.0.0  Mask:255.255.255.0<br />
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1

lo        Link encap:Local Loopback<br />
          inet addr:127.0.0.1  Mask:255.0.0.0<br />
          inet6 addr: ::1/128 Scope:Host<br />
          UP LOOPBACK RUNNING  MTU:16436  Metric:1<br />
          RX packets:0 errors:0 dropped:0 overruns:0 frame:0<br />
          TX packets:0 errors:0 dropped:0 overruns:0 carrier:0<br />
          collisions:0 txqueuelen:0<br />
          RX bytes:0 (0.0 b)  TX bytes:0 (0.0 b)</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/587689/201512/587689-20151228182600214-1090063563.png" /></p>
<div>
<pre class="prettyprint linenums">[root@node2 ~]# ipvsadm -Ln<br />
IP Virtual Server version 1.2.1 (size=4096)<br />
Prot LocalAddress:Port Scheduler Flags<br />
  -&gt; RemoteAddress:Port           Forward Weight ActiveConn InActConn<br />
TCP  192.168.103.100:80 wrr persistent 50<br />
  -&gt; 192.168.103.101:80           Route   1      0          0<br />
  -&gt; 192.168.103.105:80           Route   1      0          0</pre>
</div>
<p>上述可以看到MASTER中的网卡是启用的。</p>
<h3>3、查看BACKUP(node3)上的状态：</h3>
<div>
<pre class="prettyprint linenums">[root@node3 keepalived]# ifconfig<br />
eth0      Link encap:Ethernet  HWaddr 00:0C:29:BE:D3:CA<br />
          inet addr:192.168.103.103  Bcast:192.168.103.255  Mask:255.255.255.0<br />
          inet6 addr: fe80::20c:29ff:febe:d3ca/64 Scope:Link<br />
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1<br />
          RX packets:249981 errors:0 dropped:0 overruns:0 frame:0<br />
          TX packets:72173 errors:0 dropped:0 overruns:0 carrier:0<br />
          collisions:0 txqueuelen:1000<br />
          RX bytes:284573915 (271.3 MiB)  TX bytes:5287459 (5.0 MiB)

lo        Link encap:Local Loopback<br />
          inet addr:127.0.0.1  Mask:255.0.0.0<br />
          inet6 addr: ::1/128 Scope:Host<br />
          UP LOOPBACK RUNNING  MTU:16436  Metric:1<br />
          RX packets:1898 errors:0 dropped:0 overruns:0 frame:0<br />
          TX packets:1898 errors:0 dropped:0 overruns:0 carrier:0<br />
          collisions:0 txqueuelen:0<br />
          RX bytes:229406 (224.0 KiB)  TX bytes:229406 (224.0 KiB)</pre>
</div>
<div>
<pre class="prettyprint linenums">[root@node3 keepalived]# ipvsadm -Ln<br />
IP Virtual Server version 1.2.1 (size=4096)<br />
Prot LocalAddress:Port Scheduler Flags<br />
  -&gt; RemoteAddress:Port           Forward Weight ActiveConn InActConn<br />
TCP  192.168.103.100:80 wrr persistent 50<br />
  -&gt; 192.168.103.101:80           Route   1      0          0<br />
  -&gt; 192.168.103.105:80           Route   1      0          0</pre>
</div>
<p>如果node3没有关闭防火墙的话，也会启用eth0:1网卡，所以注意将防火墙关闭。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z6povq.html">解剖SQLSERVER 第五篇  OrcaMDF里读取Bits类型数据（译）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96x1ry9.html">不要在初始化方法和dealloc方法中使用Accessor Methods</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wjerxq.html">AspxGridView</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ymj55q.html">jacob如何获取word文档的页码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeoz0v9.html">IOS缓存之NSCache缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xy7km8.html">【CSS】Intermediate2&colon;Pseudo Classes</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0507eq.html">html--鼠标控制DIV移动</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmo6579.html">Speech Module</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp2nn59.html">&lbrack;基础架构&rsqb;PeopleSoft Process Scheduler 重要文件说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gez3g78.html">jvm系列 &lpar;四&rpar; ---强、软、弱、虚引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzrl4g8.html">javascript获取网页地址栏的id</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyz45j9.html">51nod1236 序列求和 V3</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j7gw38.html">kubernetes in action - Volumes</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojxpgxq.html">python 开发环境部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw0j0x9.html">BZOJ 5261 Rhyme</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv1lwk8.html">python基础&mdash;&mdash;1、python背景及特点&mdash;&mdash;（YZ）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wjxnrq.html">HDU - 1540 线段树的合并</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o15rg5q.html">constructor与prototype</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd7kxj9.html">ASP&period;NET Web APIs 基于令牌TOKEN验证的实现&lpar;保存到DB的Token&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1wxww9.html">set集合&comma;深浅拷⻉以及部分知识点补充</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9j03eeq.html">Linux学习之CentOS&lpar;二十&rpar;--CentOS6&period;4下修改MySQL编码方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z1ww39.html">webapi6</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pjlpd9.html">saltstack初探</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2wpm3q.html">轮播插件unsilder 源码解析&lpar;一&rpar;---源码解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gm20l9.html">关于&period;dll&amp;&num;39&semi; could not be found 的问题以及解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlmyze9.html">1&period;0、修改MyEclipse字体大小及颜色</a>
			</li>
						<li><a href="https://www.batexi.com/a/390mvy38.html">spring data jpa分页</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kp1339.html">负载均衡-基础-一致性哈希算法及java实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kpjn59.html">PHP中常见的提示对照表</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pdw2d9.html">WebForm控件--2016年12月29日</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
